//+------------------------------------------------------------------+
//|                                                Super8 Filter.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property indicator_separate_window
#property indicator_minimum -0.05
#property indicator_maximum 1.05
#property indicator_buffers 4

#property indicator_color1 MediumBlue
#property indicator_color2 LightBlue
#property indicator_color3 Orange
#property indicator_color4 Crimson

extern int linesWidth = 2;

double UpBuffer1[];
double UpBuffer2[];
double UpBuffer3[];
double UpBuffer4[];
double ind_buffer1[];
double ind_buffer2[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,UpBuffer2);
   SetIndexBuffer(2,UpBuffer3);
   SetIndexBuffer(3,UpBuffer4);
   SetIndexBuffer(4,ind_buffer1);
   SetIndexBuffer(5,ind_buffer2);
      for (int i=0; i<4; i++) SetIndexStyle(i,DRAW_HISTOGRAM,EMPTY,linesWidth);
     
   IndicatorShortName("Super 8 Filter");
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-2);


   for(int i=limit; i>=0; i--)
   {
      ind_buffer1[i]  = iMA(NULL,0,12,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,26,0,MODE_EMA,PRICE_CLOSE,i);
      ind_buffer2[i]  = iMA(NULL,0,15,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,102,0,MODE_EMA,PRICE_CLOSE,i);
      UpBuffer1[i]    = EMPTY_VALUE;
	   UpBuffer2[i]    = EMPTY_VALUE;
      UpBuffer3[i]    = EMPTY_VALUE;
      UpBuffer4[i]    = EMPTY_VALUE;
      double current  = ind_buffer1[i];
      double prev     = ind_buffer1[i+1];
      double current1 = ind_buffer2[i];
      double prev1    = ind_buffer2[i+1];
   	
   
	   int trend = 0;
         if((current>prev)&&(current1>prev1) &&  (current>0) && (current1>0) ) trend= 2;
         if((current>prev)&&(current1>prev1) && ((current<0) || (current1<0))) trend= 1;
         if((current<prev)&&(current1>prev1))                                  trend= 1;
         if((current<prev)&&(current1<prev1) &&  (current<0) && (current1<0) ) trend=-2;
         if((current<prev)&&(current1<prev1) && ((current>0) || (current1>0))) trend=-1;
         if((current>prev)&&(current1<prev1))                                  trend=-1;
      
         if(trend== 2) UpBuffer1[i]=1;
         if(trend== 1) UpBuffer2[i]=1;
         if(trend==-1) UpBuffer3[i]=1;
         if(trend==-2) UpBuffer4[i]=1;
	  }
   return(0);
}